/** Die Klasse Action dient zum Speichern der Baue/Baue-Nicht- und Richtungs-Information im Baum, der vom PatternGenerator aufgebaut wird.
 * Stand: 09.07.2001
 */

public class Action{

    protected boolean build;
    protected int direction;
    protected int numberOfJoker;

    protected int genNumber;

    /** Konstruktor erzeugt eine Action.
     *
     * @param build ob gebaut werden soll oder nicht
     * @param direction Richtung, in die weitergegangen werden soll
     * @param numberOfJoker Anzahl der Wildcards im Gen
     */
    public Action( boolean build, int direction, int numberOfJoker, int indexOfGenInGenom ){
        this.build = build;
        this.direction = direction;
        this.numberOfJoker = numberOfJoker;
	genNumber = indexOfGenInGenom;
    }

    public int getGenUsed(){
	return genNumber;
    }

    /** Ob gebaut werden soll, oder nicht
     *
     *  @return eben das
     */
    public boolean shallBuild(){
        return build;
    }

    /** Liefert die Anzahl der Joker, die sich in dem Gen befanden, aus dem sich diese Action ergeben hat.
     *
     * @return int Anzahl der Joker
     */
    public int getNumberOfJoker(){
        return numberOfJoker;
    }

    /** Liefert die Richtung, in die Gegangen werden soll. Die Drehrichtung wurde beim Erzeugen der Action bercksichtigt.
     *
     * @return int Richtung
     */
    public int whichWayToMove(){
        return direction;
    }   
}
