


// Methoden, die jetzt auskommentiert sind, werden in der nchsten Version auch hier entfernt (in Environment sind sie es natrlich schon)


public interface Simulator{
    public Koord3D[] laufeRunden(int runden);             //laesst Simulation >runden< Runden laufen
    public Koord3D[] gebautInRunde(int runde);            //liefert alle Bloecke die in Runde gebaut wurden
    public boolean nextNest();                    //schaltet auf den nextn Schwarmstock um
    public Koord3D[] getAgentPos(int runde);              //liefert die aktuelle Position des Agenten
    public Koord3D getCrystallizationPoint();             //liefert die Koordinate des ersten Steins


    public long getNumberBuiltBlocks();             // gibt die Anzahl der mit dem aktuellen Genom gebauten Steine zurck
    public int getNumberOfNests();             // gibt die Anzahl der Nesten/Genome im GenPool zurck
    public int getIndexOfCurrentNest();         // gibt den Index der aktuellen Nest im GenPool zurck
    public void setDoCrossover( boolean abler );    // enabled oder disables Crossover nachdem alle Genome eines GenPools durch sind

    public void setSizeOfView( int size );          // zum setzen der Kantenlaenge eines Sichtblocks. Fall der Wert gerade ist, wird er um eins erhoeht.

    public int getHowOftenUsed_Gen(int index );     // gibt die Anzahl der Anwendungen des durch den index spezifizierten Gens zurck
    public int getSizeGenom();                      // gibt die Anzahl der im aktuellen Genom befindlichen Gene zurck


    public void setNumberNests( int number );        // setzt die bei einem Reset neu zu erzeugenden Nesten
    public void setSizeOfNest( Koord3D size );        //die Standardgrsse (31x31x31) kann hiermit verndert werden.
                                                          //Vernderungen hier wirken sich erst auf eine nchste, neue Nest aus!
    public void setNumberGensInGenom( int number );       //wie der Name schon sagt
    public void setNumberAgents( int number );            //legt die Anzahl der Agenten in einer Nest fest
    public int getNumberAgents();

    public static final int CENTER = 0;
    public static final int MIDDLE = 1;
    public static final int CORNER = 2;
    public void setPositionCrystallizationPoint( int pos );


    public static final int FIRST       = 0;
    public static final int RANDOM      = 1;
    public static final int MOST_JOKER  = 2;
    public static final int LEAST_JOKER = 3;
    public void setResolveOfConflict( int strategy );          // bleibt fr jede Nest gleich
    public int getResolveOfConflict();                         // fr evtl. Anzeige in einem Dialog

    public boolean load(String verzeichnis,String dateiname);  //laed Nest und Genom
    public boolean loadGP( String verzeichnis );               //ldt GenPool aus angegebenem Unterverzeichnis. Aktueller GenPool wird gelscht und ersetzt
    public boolean store(String verzeichnis,String dateiname); //speichert Nest und Genom
                                                               //throws demnchst eine FileAlreadyExistsException!!!
    public boolean storeGP( String verzeichnis );              // speichert aktuellen GenPool in angegebenes Unterverzeichnis
    public boolean storeAnyways( String verzeichnis, String dateiname ); // falls eine Datei mit dem verlangten Namen schon existiert wird diese trotzdem berschrieben!

    public boolean resetNest();                  //setzt das Nest zurueck auf Anfangsrunde -> nextNest() aufrufen!
    public boolean resetTotal();                 // initialisiert Genpool und damit alle Nester neu

    public void setPropability( double value );  // hiermit wird die Wahrscheinlichkeit einer Mutation festgelegt
    public void setFitness( double value );      // legt die Fitness der aktuellen Nest fest.
}

